#ifndef OSSPLAY_DECODE_H
#define OSSPLAY_DECODE_H

#include "ossplay.h"

#define MAC_IMA_BLKLEN		34
/*
 * ima4 block length in AIFC files. Qt has "stsd" chunk which can change this,
 * but I know of no AIFC equivalent.
 */

typedef struct verbose_values {
  char tstring[20];
  double next_sec;
  double next_sec2;
  double tsecs;
  double constant;
  int format;
#ifdef OSS_NO_LONG_LONG
  unsigned long * datamark;
#else
  unsigned long long * datamark;
#endif
}
verbose_values_t;

#ifdef OSS_NO_LONG_LONG
int decode_sound (dspdev_t *, int, unsigned long, int, int, int, void *);
int encode_sound (dspdev_t *, fctypes_t, const char *, int, int, int,
                  unsigned long);
int get_db_level (const unsigned char *, ssize_t, int);
verbose_values_t * setup_verbose (int, double, unsigned long *);
#else
int decode_sound (dspdev_t *, int, unsigned long long, int, int, int, void *);
int encode_sound (dspdev_t *, fctypes_t, const char *, int, int, int,
                  unsigned long long);
int get_db_level (const unsigned char *, ssize_t, int);
verbose_values_t * setup_verbose (int, double, unsigned long long *);
#endif

#endif
