#!/bin/sh



. ./.directories

rm -rf prototype

mkdir prototype
mkdir prototype/usr
mkdir prototype/usr/bin
mkdir prototype/usr/sbin
mkdir -p prototype/$OSSLIBDIR
mkdir prototype/$OSSLIBDIR/etc
mkdir prototype/$OSSLIBDIR/lib
mkdir prototype/$OSSLIBDIR/include
mkdir prototype/$OSSLIBDIR/include/sys
mkdir prototype/$OSSLIBDIR/modules
mkdir prototype/$OSSLIBDIR/objects
mkdir prototype/$OSSLIBDIR/conf

# Regenerating the config file templates
if ! cc -o confgen ./setup/Minix/confgen.c
then
        echo Building confgen failed
        exit 1
fi


if ! ./confgen prototype/$OSSLIBDIR/conf $OSSLIBDIR/conf kernel/drv/* kernel/nonfree/drv/*
then
        echo Running confgen failed
        exit 1
fi

# Regenerating the config file templates
rm -f /tmp/gen_minix_options
if ! cc -o /tmp/gen_minix_options ./setup/Minix/gen_minix_options.c
then
        echo Building gen_minix_options failed
        exit 1
fi

if ! /tmp/gen_minix_options kernel/drv/*
then
        echo Running gen_minix_options failed
        exit 1
fi

rm -f /tmp/gen_minix_options

rm -r build objects
mkdir build objects || true

cp $SRCDIR/setup/Minix/oss/build/* $SRCDIR/kernel/OS/Minix/minixdefs.h $SRCDIR/kernel/framework/include/ossddk/oss_exports.h build

cc -c -o target/objects/mul64.o setup/Minix/mul64.s
cc -r -o build/osscore_mainline.o target/objects/*.o

for n in target/modules/*.o
do
	N=`basename $n .o`
	echo "extern int $N""_attach(oss_device_t *osdev);" >> oss_modules.h
	if [ $N != "oss_imux" ]
	then
		echo "extern device_id_t $N""_id_table[];" >> oss_modules.h
	fi
	echo "extern int $N""_type;" >> oss_modules.h
	echo "" >> oss_modules.h
done
echo "" >> oss_modules.h
echo "" >> oss_modules.h
echo "module_t modules[] = {" >> oss_modules.h
for n in target/modules/*.o
do
	N=`basename $n .o`
	if [ $N = "oss_imux" ] 
	then
		echo "{\"$N\", $N""_attach, NULL, &$N""_type}," >> oss_modules.h
	else
		echo "{\"$N\", $N""_attach, $N""_id_table, &$N""_type},">>oss_modules.h
	fi
done
echo "{0}" >> oss_modules.h
echo "};" >> oss_modules.h


(cd target/bin; rm -f ossrecord; ln -s ossplay ossrecord)

cp target/modules/*.o objects
cp target/build/*.c oss_modules.h minix_options.h  build

cp target/bin/* prototype/usr/bin/
cp target/sbin/* prototype/usr/sbin/
cp $SRCDIR/setup/Minix/sbin/* prototype/usr/sbin/

chmod 700 prototype/usr/sbin/*
chmod 755 prototype/usr/bin/*
chmod 700 prototype/$OSSLIBDIR
